general <- "/home/jmateu/Documents/Codes/geostats/microscale_LUR/"


library("readxl")

crs_latlon      <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0"
crs_utm         <- "+proj=utm +zone=31 +ellps=intl +units=m +no_defs"


############################################################
#                                                          #
#               campanyes Generalitat                      #
#                                                          #
############################################################
campana1_NO2 <- readxl::read_excel(path=paste0(general, "Resultats_campanya_passius_BSC.xlsx"))
names(campana1_NO2) <- c("municipy", "location","Y", "X","promotor","period_1","NO2_1","period_2","NO2_2","period_3",
                     "NO2_3","period_4","NO2_4","period_5","NO2_5","period_6","NO2_6","period_7","NO2_7","period_8","NO2_8")
campana1_NO2 <- as.data.frame(campana1_NO2)
campana1_NO2 = subset(campana1_NO2, !is.na(campana1_NO2$X))
campana1_NO2 = subset(campana1_NO2, !is.na(campana1_NO2$Y))
sp::coordinates(campana1_NO2) <- c("X", "Y")
sp::proj4string(campana1_NO2) <- sp::CRS(crs_latlon)
mapview::mapview(campana1_NO2)


# Annualization to be done
campana_NO2 <- data.frame(X=campana1_NO2$X,Y=campana1_NO2$Y,NO2=campana1_NO2$NO2_1)

sp::coordinates(campana_NO2) <- c("X", "Y")
sp::proj4string(campana_NO2) <- sp::CRS(crs_latlon)
campana_NO2 <- sp::spTransform(campana_NO2, sp::CRS(crs_utm))
mapview::mapview(campana_NO2)

# Gather all dosimeters. Annualization to be done
all_campaigns <- data.frame(X=campana_NO2@coords[,1],Y=campana_NO2@coords[,2],NO2=campana_NO2@data$NO2)


sp_all_campaigns <- all_campaigns
sp::coordinates(sp_all_campaigns) <- c("X", "Y")
sp::proj4string(sp_all_campaigns) <- sp::CRS(crs_utm)
mapview::mapview(sp_all_campaigns)


############################################################
#                                                          #
#                campanyes Aj. Barcelona                   #
#                                                          #
############################################################
# data is duplicated (at least partly)

# campana2_NO2 <- readxl::read_excel(path=paste0(general, "20221122_PUNTS_PASSIUS_v2021.xlsx"))
# names(campana2_NO2) <- c("location","X", "Y","NO2_1","NO2_2","NO2_3","year_1","year_2","year_3","period_1", "period_2","period_3")
# campana2_NO2 <- as.data.frame(campana2_NO2)
# campana2_NO2 = subset(campana2_NO2, !is.na(campana2_NO2$X))
# campana2_NO2 = subset(campana2_NO2, !is.na(campana2_NO2$Y))
# sp::coordinates(campana2_NO2) <- c("X", "Y")
# sp::proj4string(campana2_NO2) <- sp::CRS("+proj=utm +zone=31 +ellps=intl +units=m +no_defs")
# #campana2_NO2@data <- cbind(campana2_NO2@data, campana2_NO2@coords)
# 
# mapview::mapview(campana2_NO2)
# 
# single_campaign <- data.frame(X=campana2_NO2@coords[,1],Y=campana2_NO2@coords[,2],NO2=campana2_NO2@data$NO2_1)
# 
# # Gather all dosimeters. Annualization to be done
# all_campaigns <- rbind(all_campaigns, single_campaign)
# 
# 
# 
# sp_all_campaigns <- all_campaigns
# sp::coordinates(sp_all_campaigns) <- c("X", "Y")
# sp::proj4string(sp_all_campaigns) <- sp::CRS(crs_utm)
# mapview::mapview(sp_all_campaigns)

############################################################
#                                                          #
#                  Campanya Sabadell                       #
#                                                          #
############################################################
sabadell_NO2_2018 <- sf::st_read(paste0(general, "Dades_captadors_passius_ajuntament_2018.gpkg"))

NO2_corr <- as.numeric(gsub(",", ".", sf_utm$P1.æg.m3))

single_campaign <- data.frame(Y=sabadell_NO2_2018$LATITUD..r,X=sabadell_NO2_2018$LONGITUD..,NO2=NO2_corr)


sp::coordinates(single_campaign) <- c("X", "Y")
sp::proj4string(single_campaign) <- sp::CRS(crs_latlon)
single_campaign <- sp::spTransform(single_campaign, sp::CRS(crs_utm))
mapview::mapview(single_campaign)
single_campaign <- data.frame(X=single_campaign@coords[,1],Y=single_campaign@coords[,2],NO2=single_campaign@data$NO2)
# Gather all dosimeters. Annualization to be done

all_campaigns <- rbind(all_campaigns, single_campaign)

sp_all_campaigns <- all_campaigns
sp::coordinates(sp_all_campaigns) <- c("X", "Y")
sp::proj4string(sp_all_campaigns) <- sp::CRS(crs_utm)
mapview::mapview(sp_all_campaigns)
